/*************************************************************
	Unofficial McAfee SiteAdvisor button for Google Search
	Maxthon Toolbar Button Plugin
	By neo101
	licensed under a Creative Commons Attribution No-Derivs 2.5 License 
	http://creativecommons.org/licenses/by-nd/2.5/
*************************************************************/



function start(){
	externalLinks = getLinks()
	if(externalLinks.length > 0){
		SiteAdvisor.analyzeMultipleDomains(externalLinks, displayResult)
	} else {
		alert('error getting links...')
	}
}


function displayResult(dataArray){
	for(var i=0; i<dataArray.length; i++){
		externalLinks[i][2] = dataArray[i]
	}
	var isDisplayed = false
	var html
	for(var i=0; i<externalLinks.length; i++){
		if(externalLinks[i][2]){
			html = '<span class="siteAdvisorButton" onmouseover="showTooltip(externalLinks[' + i + '][2], this)">' + 
						returnHtmlImage(externalLinks[i][2].classificationCode) +
					'</span>'
			externalLinks[i][1].insertAdjacentHTML('afterEnd', html)
			isDisplayed = true
		}
	}
	if(isDisplayed == false){
		//alert('error')
	}
	
	var stylesheet = external.m2_plugin_folder(SECURITY_ID,PLUGIN_NAME) + "stylesheet.css";
	var element = document.createElement('<link rel="stylesheet" href=\"'+stylesheet+'" type="text/css" />')
	document.documentElement.childNodes[0].appendChild( element );
	Tooltip.init()
	window.externalLinks = externalLinks
}


window.showTooltip = function(data, node){
	if(node.onmouseout == null){
		node.onmouseout = Tooltip.hideTooltip
	}
	var yearCreated = getYear(data.domainAge)
	var html = ''
	var imageHtml
	
	html += '<h1>SiteAdvisor for ' + data.domain + '</h1>'
	
	imageHtml = returnHtmlImage(data.classificationCode)
	html += (imageHtml ? imageHtml : '?') + ' ' + data.classificationDescription
	
	html += '<ul>'
	
	imageHtml = returnHtmlImage(data.downloadsInfoCode, true)
	if(imageHtml){
		html += '<li>' + imageHtml + ' ' + data.downloadsInfoShortDescription + '</li>'
	}
	
	imageHtml = returnHtmlImage(data.personalInfoCode, true)
	if(imageHtml){
		html += '<li>' + imageHtml + ' ' + data.personalInfoShortDescription + '</li>'
	}
	
	imageHtml = returnHtmlImage(data.annoyanceInfoCode, true)
	if(imageHtml){
		html += '<li>' + imageHtml + ' ' + data.annoyanceInfoShortDescription + '</li>'
	}
	
	imageHtml = returnHtmlImage(data.linksInfoCode, true)
	if(imageHtml){
		html += '<li>' + imageHtml + ' ' + data.linksInfoShortDescription + '</li>'
	}
	
	html += '</ul>'

	Tooltip.showTooltip(html)
	setColor(data.classificationCode)
}


function returnHtmlImage(code, noUnknown){
	var codes = {'OK':'green', 'WARN':'red', 'INFO': 'yellow', 'CERTIFIED':'green', 'UNKNOWN':'untested'}
	if(code in codes && !(noUnknown && code == 'UNKNOWN')){
		return '<img src="' + external.m2_plugin_folder(SECURITY_ID,PLUGIN_NAME) + 'images/' + codes[code] + '.gif" alt="" />'
	}
	return null
}


function setColor(code){
	var codes = {'OK':'green', 'WARN':'red', 'INFO': 'yellow', 'CERTIFIED':'green', 'UNKNOWN':'black'}
	if(code in codes){
		try{
			document.getElementById('tooltip').style.borderColor = codes[code]
		}catch(e){}
	}
}


function getLinks(){
	var nodes = document.getElementsByTagName('a')
	var result = new Array()
	var item, node
	for(var i=0; i<nodes.length; i++){
		node = nodes[i]
		item = new Array()
		if(node.className == 'l'){
			item[0] = getDomain(node.href)
			item[1] = node
			if(item[0]){
				result.push(item)
			}
		} else if(node.id.substring(0,2) == 'pa' || node.id.substring(0,2) == 'an'){
			item[0] = getDomain(node.href.substring(20,999))
			item[1] = node
			if(item[0]){
				result.push(item)
			}
		}
	}
	return result
}


function getYear(seconds){
	if(seconds == 0){
		return 'unknown'
	}
	var date = new Date()
	date.setTime(seconds * 1000) // milliseconds since 1970
	return date.getFullYear()
}


function getDomain(url){
	url = url.replace(/http:\/\/www.google.com\/interstitial\?url=/,'') + '/'
	var match = url.match(/https?:\/\/(.+?)(\/|&).*/i)
	if(match){
		return (match[1] != '' ? match[1] : match[2]).replace(/^www\./,'')
	}
	return null
}
